<?php

/*---------------------------------------------------*
 *  Dinh Quoc Han @ 2014
 *---------------------------------------------------*/
/* Create Custom Post */
add_action( 'init', 'DQH_ChapterType' );

function DQH_ChapterType() {
    register_post_type( 'chapter',
        array(
            'labels' => array(
            'name' => 'Chương truyện',
            'singular_name' => 'Chương truyện'
        ),
        'show_ui' => true,
        'public' => true,
        'has_archive' => true,
        'taxonomies'    => array('post_tag'),
        'rewrite' => array('slug' => 'chapter', 'with_front' => FALSE),
        'supports' => array( 'title', 'editor', 'author', 'excerpt', 'comments' )
    ));
}

add_action( 'edit_form_after_title', 'DQH_ChapterParrentAdmin' );
function DQH_ChapterParrentAdmin( $postData = false ){
    $scr    = get_current_screen();
    $value  = '';
    $title = '';
    $id = 0;

    $postDataNew = (isset($_GET['parent_id'])) ? $_GET['parent_id'] : 0;
    if ( $postData ) {
        $t = get_post($postData);
        $a = get_post($t->post_parent);
        $title = $a->post_title;
        $id     = $a->ID;
    }
    
    if(empty($title)) {
        $t = get_post($postDataNew);
        $title = $t->post_title;
        $id     = $t->ID;       
    }

    if ($scr->id == 'chapter'){
        if(!empty($title)){
            echo '<input type="hidden" name="parent_id" value="'.$id.'">';
            echo '<label>Truyện gốc:</label> <strong>'.$title.'</strong>';
        } else {
            echo '<label>Truyện gốc:</label> <input type="number" name="parent_id" value="0"> (<em>Nhập ID truyện gốc</em>)';
        }

    }
}

/*  Save Post */

add_action( 'save_post', 'DQH_SavePosy' );
function DQH_SavePosy( $post_id ) {
    $chapterID = isset( $_POST['parent_id'] ) ? $_POST['parent_id'] : false ;
    if ( ! wp_is_post_revision( $post_id ) && $chapterID ){
        remove_action('save_post', 'DQH_SavePosy');
        $postdata = array(
            'ID' => $post_id,
            'post_parent' => $chapterID
        );
        wp_update_post( $postdata );
        add_action('save_post', 'DQH_SavePosy');
    }
}

/* Add Custom Manager Post */
add_action( 'admin_init', 'DQH_AddCustomColunm' );

function DQH_AddCustomColunm(){
    if(($_GET['post_type']) != "chapter"):
        add_action( 'manage_posts_custom_column' , 'DQH_ColunmManagerPost', 10, 2 );
        add_filter( 'manage_posts_columns' , 'DQH_ColunmManagerPostTitle' );
    endif;
}

function DQH_ColunmManagerPostTitle( $columns ) {
    return array_merge( $columns, array( 'DQH_AddChapter' => __( 'Chapter') ) );
}
function DQH_ColunmManagerPost( $column, $post_id ) {
   if($column == "DQH_AddChapter"){
       $html = '<a href="'. admin_url('post-new.php?post_type=chapter&parent_id='. $post_id).'" class="button button-primary" title="Add more chapter">Thêm chương mới</a>';
       echo $html;
   }
}

/* Add Menu Admin Post Chapter */
add_action( 'pre_get_posts', 'DQH_AddMenuAdminItemsDo' );

function DQH_AddMenuAdminItemsDo(){
    $getNamePostType = get_query_var('post_type');
    if(is_single () && $getNamePostType == '') add_action('admin_bar_menu', 'DQH_AddMenuAdminItems', 100);
}


function DQH_AddMenuAdminItems($admin_bar){
    $admin_bar->add_menu( array(
        'id'    => 'add-chapter',
        'title' => 'Thêm chương mới',
        'href'  => admin_url('post-new.php?post_type=chapter&parent_id='. get_the_ID()),
        'meta'  => array(
            'title' => __('Thêm chương mới'),          
        ),
    ));
}

/* List Chapter */
function DQH_GetListChapters( $id = 0, $drop = false) {
    global $post, $wpdb;
    $id = ($id <= 0) ? get_the_ID() : $id;
    $current_post_id = get_the_ID();
    $query = $wpdb->get_results(sprintf('select ID, post_title from %s where post_type = \'%s\' and post_parent = %d and post_status = \'%s\' order by ID', $wpdb->posts, 'chapter', $id, 'publish'));
    $out   = '';

    if ($query) {
        $out .= '<ul class="'.($drop ? 'dropdown-menu' : 'list-chapters').'" role="menu" aria-labelledby="chapterlist">';
        foreach ( $query as $k ) {
            $uri = get_permalink($k->ID);
                $out .= '<li><a href="'.$uri.'" title="'.$k->post_title.'">'.$k->post_title .'</a></li>';
        }
        $out .=  '</ul>';
    }

    echo $out;
}

function DQH_GetListChaptersUpdated( $id = 0) {
    global $post, $wpdb;
    $id = ($id <= 0) ? get_the_ID() : $id;
    $current_post_id = get_the_ID();
    $query = $wpdb->get_results('select ID, post_title, DATE_FORMAT(post_modified, \'%d/%m/%Y\') as post_modified from '.$wpdb->posts.' where post_type = \'chapter\' and post_parent = '.$id.'  and post_status = \'publish\' order by post_modified limit 5');
    $out   = '';

    if ($query) {
        foreach ( $query as $k ) {
            $uri = get_permalink($k->ID);
            $out .=  '<p><a href="'.$uri.'" title="'.$k->post_title.'">'.$k->post_title .'</a> - '.$k->post_modified.'</p>';
        }

    }

    echo $out;
}

/* Custom fields */
function the_parent_post(){
    global $post;
    $out = '<a href="'.get_permalink($post->post_parent).'" title='.get_the_title($post->post_parent).'">'.get_the_title($post->post_parent).'</a>';
    return $out;
}

function the_next_chapter($id = 0){
    global $post, $wpdb;
    $id = ($id <= 0) ? get_the_ID() : $id;
    $k = $wpdb->get_row(sprintf('select ID, post_title from %s where post_type = \'%s\' and post_parent = %d and post_status = \'%s\' and ID > %s ORDER BY ID', $wpdb->posts, 'chapter', $post->post_parent, 'publish', $id));
    if ($k) {
        $uri = get_permalink($k->ID);
        $out = '<a href="'.$uri.'" rel="next" title="'.$k->post_title.'" class="btn-blue">Next</a>';
        
        return $out;
    }
}

function the_previous_chapter($id = 0){
    global $post, $wpdb;
    $id = ($id <= 0) ? get_the_ID() : $id;
    $k = $wpdb->get_row(sprintf('select ID, post_title from %s where post_type = \'%s\' and post_parent = %d and post_status = \'%s\' and ID < %s ORDER BY ID DESC', $wpdb->posts, 'chapter', $post->post_parent, 'publish', $id));
    if ($k) {
        $uri = get_permalink($k->ID);
        $out = '<a href="'.$uri.'" rel="previous" title="'.$k->post_title.'" class="btn-blue">Prev</a>';
        
        return $out;
    }
}

function the_first_post_url($id = 0){
    global $post, $wpdb;
    $id = ($id <= 0) ? get_the_ID() : $id;
    $k = $wpdb->get_row(sprintf('select ID from %s where post_type = \'%s\' and post_parent = %d and post_status = \'%s\' ORDER BY ID LIMIT 1', $wpdb->posts, 'chapter', $post->ID, 'publish', $id));
    if ($k) {
        $uri = get_permalink($k->ID);        
        echo  $uri;
    }
}




function DQH_add_content_post( $content ){
    global $post;

    $new_addion = '';

    if(get_post_type() == 'chapter'):
         $new_addion .= '<h4>'.the_parent_post() .'</h4><p>'.DQH_GetListChapters($post->post_parent).'</p>';
    else:
        $new_addion .= '<h4>'.the_parent_post() .'</h4><p>'.DQH_GetListChapters($post->ID).'</p>';
    endif;

    $content .= $new_addion;

    return $content;
}
// add_filter( 'the_content', 'DQH_add_content_post' );

/*---------------------------------------------------*
 *  Dinh Quoc Han @ 2014
 *---------------------------------------------------*/
